divert(-1)
changecom(`\\')
\\ buildant.m4
\\   Macros to autogenerate build.sh for Ant projects
\\   Jack J. Woehr
\\   1999-07-25
\\ $Id: buildant.m4,v 1.13 2004/11/26 09:10:26 jax Exp $
\\ Diversion prepared for restoration
\\ USAGE: push_divert(streamName)
\\ DEFINES: `temp_diversion'
define(`push_divert',`dnl
pushdef(`temp_diversion', divnum)dnl
divert($1)dnl
')dnl
divert(0)dnl
push_divert(-1)

\\ Restore previous pushed diversion
\\ USAGE: pop_divert()
\\ DEPENDS: `temp_diversion'
define(`pop_divert',`dnl
divert(temp_diversion)dnl
popdef(`temp_diversion')dnl
')

\\ Stream definitions
define(`normal_stream',           `0')        # Standard output
define(`file_header_stream',      `2')        # Stream on which we define file header
define(`file_footer_stream',      `3')        # Stream on which we define file header
define(`options_usage_stream',    `4')        # Stream on which we record script usage
define(`options_defaults_stream', `5')        # Stream on which we record the option defaults
define(`options_list_stream',     `6')        # Stream on which we record the list of option id's for usage help
define(`options_id_stream',       `7')        # Stream on which we record the string of option id's
define(`options_switch_stream',   `8')        # Stream on which we record the options switch statement
define(`options_func_stream',     `9')        # Stream on which we record the function that sets the options
define(`invocation_stream',      `10')        # Stream on which we record the invocation of Ant
define(`null_stream',            `-1')        # The bit bucket

\\ The undiversions we do at the end
\\ so as to pour our build script out
\\ into the normal output stream.
define(`do_undiversions',`dnl
push_divert(normal_stream)dnl
undivert(file_header_stream)dnl
undivert(options_usage_stream)dnl
undivert(options_defaults_stream)dnl
undivert(options_func_stream)dnl
undivert(options_id_stream)dnl
undivert(options_switch_stream)dnl
undivert(invocation_stream)dnl
undivert(file_footer_stream)dnl
pop_divert()dnl
')

\\ gen_header(text)
define(`gen_header',`dnl
push_divert(file_header_stream)dnl
`$1'dnl
pop_divert()dnl
')

\\ gen_infohdr()
define(`gen_infohdr',`dnl
push_divert(file_header_stream)dnl
changecom(`\\')dnl
######
# Autogenerated esyscmd(`date')dnl
# by BuildAnt http://www.softwoehr.com/softwoehr/oss/
# Do not edit this file.
# Instead edit __file__ from which this file is autogenerated.
######
changecom(`#')dnl
pop_divert()dnl
')

\\ start_usage()
define(`start_usage',`dnl
push_divert(options_usage_stream)dnl

# Self documentation 
USAGE_MESSAGE=`"'
Usage: `$'0  [-option] [-option] ... [--] [-ant_option] [-ant_option] ... [target] [target] ...

    If no targets are passed in, the default target in build.xml will be built.
    Options set in this file override any set in build properties files. The options
    set in this file may also result in calculated settings overriding other options
    in build properties files. To pass options to Ant itself, use the -- option to
    end the options list ... all subsquent options will then be passed to Ant itself.

    All options are:

         -h
             ... Display this help message and exit with return of 0.

         -f buildfile_path
             ... Use the buildfile specified by buildfile_path

pop_divert()dnl
')

\\ start_defaults()
define(`start_defaults',`dnl
push_divert(options_defaults_stream)dnl
# One default to allow you to compose an option for a custom
# Ant invocation ... just define an option called "ant.invocation"
# to override this as used below for the build command.
ANTBUILD_ant_invocation="ant"

# The pathname, relative or absolute, to the build file.
# See the -f option
ANTBUILD_buildfile_path="./build.xml"

# These are the defaults for various options.
# Their names represent the ant properties they shadow in this shell script.

pop_divert()dnl
')

\\ start_function()
define(`start_function',`dnl
push_divert(options_func_stream)dnl
###################################################################
# Function to show a message (and exit if numerical status given).
# Usage: 
#	display_usage
#		- or -
#	display_usage 0
#               - or, e.g. -
#       display_usage 37
###################################################################
function display_usage `('`)' {
	cat << END
`$'{USAGE_MESSAGE}
END
if [ `$'`#' -gt 0 ]
then
	`exit' `$'1
fi
}

#######################################################################
# Function converts script args to Ant build properties as appropriate.
#######################################################################
function convert_args_to_properties `('`)' {
pop_divert()dnl
')

define(`start_options_ids',`dnl
push_divert(options_id_stream)dnl

# Get arguments to script
while getopts `hf:'dnl
pop_divert()dnl
')

\\ start_options_switch()
define(`start_options_switch',`dnl
push_divert(options_switch_stream)dnl
        do
        case `$'an_opt in
           h) display_usage 0;;
           f) ANTBUILD_buildfile_path=${OPTARG};;
pop_divert()dnl
')

\\ gen_option_varname(ant.property)
define(`gen_option_varname',`dnl
`ANTBUILD_'patsubst($1,`\.',`_')')

\\ add_option_to_usage(opt,description,argument_name,takes_arg)
define(`add_option_to_usage',`dnl
push_divert(options_usage_stream)dnl
         -$1 ifelse(`$4',`y',`$3')
             ... $2

pop_divert()dnl
')

\\ add_option_to_defaults(opt,ant_property,default)
define(`add_option_to_defaults',`dnl
push_divert(options_defaults_stream)dnl
# option -$1
gen_option_varname($2)=`"'$3`"'    

pop_divert()dnl
')

\\ add_option_to_function(opt,ant_property)
define(`add_option_to_function',`dnl
push_divert(options_func_stream)dnl

    # option -$1
    if [ -n `"$'{gen_option_varname($2)}`"' ]
    then
	ANTBUILD_BUILD_PROPERTIES="${ANTBUILD_BUILD_PROPERTIES} `-D'$2=`${'gen_option_varname($2)`}'"
    fi
pop_divert()dnl
')

\\ add_option_to_ids(option_char,y_takes_argument)
define(`add_option_to_ids',`dnl
push_divert(options_id_stream)dnl
`$1'ifelse($2, `y', `:')dnl
pop_divert()dnl
')

\\ add_option_to_switch(option_char,ant_property,y_takes_argument)
define(`add_option_to_switch',`dnl
push_divert(options_switch_stream)dnl
           `$1') ifelse(`$3', `y', `gen_option_varname($2)=${OPTARG};;',`gen_option_varname($2)=true;;')
pop_divert()dnl
')

\\ option(opt_letter,ant_property,description,default,y_takes_arg)
define(`build_option',`dnl
pushdef(`my_opt',`substr(`$1',0,1)')dnl
pushdef(`my_ant_property',`$2')dnl
pushdef(`my_description',`$3')dnl
pushdef(`my_default',`$4')dnl
pushdef(`my_takes_arg',`$5')dnl
pushdef(`my_argument_name', `$6')dnl
add_option_to_usage(my_opt(),my_description(),my_argument_name(),my_takes_arg())dnl
add_option_to_defaults(my_opt(),my_ant_property(),my_default())dnl
add_option_to_function(my_opt(),my_ant_property())dnl
add_option_to_ids(my_opt(),my_takes_arg())dnl
add_option_to_switch(my_opt(),my_ant_property(),my_takes_arg())dnl
popdef(`my_argument_name')dnl
popdef(`my_takes_arg')dnl
popdef(`my_default')dnl
popdef(`my_description')dnl
popdef(`my_ant_property')dnl
popdef(`my_opt')dnl
')

\\ end_usage()
define(`end_usage',`dnl
push_divert(options_usage_stream)dnl
`"'

pop_divert()dnl
')

\\ end_options_ids()
define(`end_options_ids',`dnl
push_divert(options_id_stream)dnl
` an_opt'

pop_divert()dnl
')

\\ end_options_switch()
define(`end_options_switch',`dnl
push_divert(options_switch_stream)dnl

          `\'`?') echo "Invalid option \"-${OPTARG}\" to `$'0"
              display_usage 1;;
        esac
        done

# Clean up options
changequote([,])dnl
[shift]' changequote([,])[`]expr ${OPTIND} - 1[`]
changequote(`,')dnl
`changequote(`,')dnl
pop_divert()dnl
')

\\ start_invocation()
define(`start_invocation',`dnl
push_divert(invocation_stream)dnl

# What is left is the build target(s)
# and any options like -v for Ant.
`TRAILING_OPTIONS_AND_BUILD_TARGETS="'`$'`*"'

# Process the arguments we got from the command line
convert_args_to_properties

######################
# Prepare command line
######################

# Forumulate the build command.
ANTBUILD_BUILD_COMMAND="${ANTBUILD_ant_invocation} -f ${ANTBUILD_buildfile_path} ${ANTBUILD_BUILD_PROPERTIES} ${TRAILING_OPTIONS_AND_BUILD_TARGETS}"

# Announce
echo "Ant invocation will be issued as follows: "
echo "${ANTBUILD_BUILD_COMMAND}"

# Do it!
${ANTBUILD_BUILD_COMMAND}

pop_divert()dnl
')

\\ end_invocation()
define(`end_invocation',`')

\\ end_function()
define(`end_function',`dnl
push_divert(options_func_stream)dnl
`}'
pop_divert()dnl
')

\\ end_defaults()
define(`end_defaults',`')

define(`trailer',`dnl
###############
# end of script
###############
')

define(`gen_trailer',`dnl
push_divert(file_footer_stream)dnl
trailer()dnl
pop_divert()dnl
')

\\open_buildant(file_header)
define(`open_buildant',`dnl
gen_header(`$1')dnl
gen_infohdr()dnl
start_usage()dnl
start_defaults()dnl
start_function()dnl
start_options_ids()dnl
start_options_switch()dnl
start_invocation()dnl
')

\\ close_buildant()
define(`close_buildant',`dnl
ifelse(`$1',`',`',`dnl
push_divert(options_usage_stream)dnl
`$1'dnl
pop_divert()')dnl
end_usage()dnl
end_defaults()dnl
end_function()dnl
end_options_ids()dnl
end_options_switch()dnl
end_invocation()dnl
gen_trailer()dnl
do_undiversions()dnl
')

\\ End of buildant.m4
pop_divert()dnl
changecom(`#')dnl
